'From OLPC2.0 of ''24 October 2006'' [latest update: #1471] on 15 August 2007 at 10:33:47 am'!
"Change Set:		networkFix-mir-bf
Date:			19 July 2007
Author:			Michael Rueger, Bert Freudenberg

Fix non-blocking socket connection (mir).
Fix getting local host address (bf)"!


!NetNameResolver class methodsFor: 'lookup' stamp: 'bf 7/19/2007 13:15'!
localHostAddress
	"Return the local address of this host."
	"NetNameResolver localHostAddress"

	^NetNameResolver addressForName: self localHostName! !


!Socket methodsFor: 'connection open/close' stamp: 'bf 7/19/2007 15:12'!
connectNonBlockingTo: hostAddress port: port
	"Initiate a connection to the given port at the given host address. This operation will return immediately; follow it with waitForConnectionUntil: to wait until the connection is established."

	| status |
	self initializeNetwork.
	status _ self primSocketConnectionStatus: socketHandle.
	(status == Unconnected)
		ifFalse: [InvalidSocketStatusException signal: 'Socket status must Unconnected before opening a new connection'].

	NetNameResolver useOldNetwork
		ifTrue: [self primSocket: socketHandle connectTo: hostAddress port: port]
		ifFalse: [
			hostAddress port: port.
			self connectNonBlockingTo: hostAddress]! !

